'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _routeManager = require('./route-manager');

var _routeManager2 = _interopRequireDefault(_routeManager);

var _webpack = require('./webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpack3 = require('webpack');

var _webpack4 = _interopRequireDefault(_webpack3);

var _memoryFs = require('memory-fs');

var _memoryFs2 = _interopRequireDefault(_memoryFs);

var _chokidar = require('chokidar');

var _chokidar2 = _interopRequireDefault(_chokidar);

var _lodash = require('lodash.template');

var _lodash2 = _interopRequireDefault(_lodash);

var _fsExtra = require('fs-extra');

var _path = require('path');

var _connectHistoryApiFallback = require('connect-history-api-fallback');

var _connectHistoryApiFallback2 = _interopRequireDefault(_connectHistoryApiFallback);

var _webpackDevMiddleware = require('webpack-dev-middleware');

var _webpackDevMiddleware2 = _interopRequireDefault(_webpackDevMiddleware);

var _webpackHotMiddleware = require('webpack-hot-middleware');

var _webpackHotMiddleware2 = _interopRequireDefault(_webpackHotMiddleware);

var _htmlWebpackPlugin = require('html-webpack-plugin');

var _htmlWebpackPlugin2 = _interopRequireDefault(_htmlWebpackPlugin);

var _vueSkeletonWebpackPlugin = require('vue-skeleton-webpack-plugin');

var _vueSkeletonWebpackPlugin2 = _interopRequireDefault(_vueSkeletonWebpackPlugin);

var _constants = require('./constants');

var _webpack5 = require('./utils/webpack');

var _path2 = require('./utils/path');

var _router = require('./utils/router');

var _json = require('./utils/json');

var JsonUtil = _interopRequireWildcard(_json);

var _template = require('./utils/template');

var _template2 = _interopRequireDefault(_template);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function templatesPath(path) {
    return (0, _path.join)(__dirname, 'templates', path);
}

var Builder = function () {
    function Builder(core) {
        (0, _classCallCheck3.default)(this, Builder);

        this.core = core;
        this.env = core.env;
        this.cwd = core.cwd;
        this.lavasDir = (0, _path.join)(core.config.globals.rootDir, './.lavas');
        this.renderer = core.renderer;
        this.watchers = [];
        this.devMiddleware = null;
        this.sharedCache = {};
        this.init(core.config);
    }

    (0, _createClass3.default)(Builder, [{
        key: 'init',
        value: function init(config) {
            this.config = config;
            this.webpackConfig = new _webpack2.default(config, this.env);
            this.routeManager = new _routeManager2.default(config, this.env);
            this.ssrExists = config.entry.some(function (e) {
                return e.ssr;
            });
            this.mpaExists = config.entry.some(function (e) {
                return !e.ssr;
            });
        }
    }, {
        key: 'createSkeletonEntry',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(entryName, skeletonPath) {
                var skeletonEntryTemplate, entryPath, writeFile;
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                skeletonEntryTemplate = templatesPath('entry-skeleton.tpl');
                                entryPath = (0, _path.join)(this.lavasDir, entryName + '/skeleton.js');
                                writeFile = this.isDev ? _webpack5.writeFileInDev : _fsExtra.outputFile;
                                _context.t0 = writeFile;
                                _context.t1 = entryPath;
                                _context.t2 = _lodash2.default;
                                _context.next = 8;
                                return (0, _fsExtra.readFile)(skeletonEntryTemplate, 'utf8');

                            case 8:
                                _context.t3 = _context.sent;
                                _context.t4 = (0, _context.t2)(_context.t3);
                                _context.t5 = {
                                    skeleton: {
                                        path: skeletonPath
                                    }
                                };
                                _context.t6 = (0, _context.t4)(_context.t5);
                                _context.next = 14;
                                return (0, _context.t0)(_context.t1, _context.t6);

                            case 14:
                                return _context.abrupt('return', entryPath);

                            case 15:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function createSkeletonEntry(_x, _x2) {
                return _ref.apply(this, arguments);
            }

            return createSkeletonEntry;
        }()
    }, {
        key: 'createHtmlTemplate',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(sourcePath, targetPath) {
                var baseUrl = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '/';
                var writeFile, clientTemplateContent;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                writeFile = this.isDev ? _webpack5.writeFileInDev : _fsExtra.outputFile;
                                _context2.t0 = _template2.default;
                                _context2.next = 4;
                                return (0, _fsExtra.readFile)(sourcePath, 'utf8');

                            case 4:
                                _context2.t1 = _context2.sent;
                                _context2.t2 = baseUrl;
                                clientTemplateContent = _context2.t0.client.call(_context2.t0, _context2.t1, _context2.t2);
                                _context2.next = 9;
                                return writeFile(targetPath, clientTemplateContent);

                            case 9:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function createHtmlTemplate(_x3, _x4) {
                return _ref2.apply(this, arguments);
            }

            return createHtmlTemplate;
        }()
    }, {
        key: 'addHtmlPlugin',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(mpaConfig, entryName, baseUrl) {
                var _this = this;

                var rootDir, htmlFilename, customTemplatePath, realTemplatePath;
                return _regenerator2.default.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                rootDir = this.config.globals.rootDir;
                                htmlFilename = entryName + '.html';
                                customTemplatePath = (0, _path.join)(rootDir, 'entries/' + entryName + '/' + _constants.TEMPLATE_HTML);
                                _context4.next = 5;
                                return (0, _fsExtra.pathExists)(customTemplatePath);

                            case 5:
                                if (_context4.sent) {
                                    _context4.next = 7;
                                    break;
                                }

                                throw new Error(_constants.TEMPLATE_HTML + ' required for entry: ' + entryName);

                            case 7:
                                realTemplatePath = (0, _path.join)(this.lavasDir, entryName + '/' + _constants.TEMPLATE_HTML);
                                _context4.next = 10;
                                return this.createHtmlTemplate(customTemplatePath, realTemplatePath, baseUrl);

                            case 10:
                                mpaConfig.plugins.unshift(new _htmlWebpackPlugin2.default({
                                    filename: htmlFilename,
                                    template: realTemplatePath,
                                    inject: true,
                                    minify: {
                                        removeComments: true,
                                        collapseWhitespace: true,
                                        removeAttributeQuotes: true
                                    },
                                    favicon: (0, _path2.assetsPath)('img/icons/favicon.ico'),
                                    chunksSortMode: 'dependency',
                                    cache: false,
                                    chunks: ['manifest', 'vue', 'vendor', entryName],
                                    config: this.config }));

                                if (this.isDev) {
                                    this.addWatcher(customTemplatePath, 'change', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
                                        return _regenerator2.default.wrap(function _callee3$(_context3) {
                                            while (1) {
                                                switch (_context3.prev = _context3.next) {
                                                    case 0:
                                                        _context3.next = 2;
                                                        return _this.createHtmlTemplate(customTemplatePath, realTemplatePath, baseUrl);

                                                    case 2:
                                                    case 'end':
                                                        return _context3.stop();
                                                }
                                            }
                                        }, _callee3, _this);
                                    })));
                                }

                            case 12:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function addHtmlPlugin(_x6, _x7, _x8) {
                return _ref3.apply(this, arguments);
            }

            return addHtmlPlugin;
        }()
    }, {
        key: 'createMPAConfig',
        value: function () {
            var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
                var _this2 = this;

                var rootDir, mpaConfig, skeletonEntries, skeletonConfig;
                return _regenerator2.default.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                rootDir = this.config.globals.rootDir;
                                mpaConfig = this.webpackConfig.client();
                                skeletonEntries = {};

                                mpaConfig.entry = {};
                                mpaConfig.name = 'mpaclient';
                                mpaConfig.context = rootDir;

                                _context6.next = 8;
                                return _promise2.default.all(this.config.entry.map(function () {
                                    var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(entryConfig) {
                                        var entryName, needSSR, baseUrl, skeletonPath, skeletonImportPath, entryPath;
                                        return _regenerator2.default.wrap(function _callee5$(_context5) {
                                            while (1) {
                                                switch (_context5.prev = _context5.next) {
                                                    case 0:
                                                        entryName = entryConfig.name, needSSR = entryConfig.ssr, baseUrl = entryConfig.base;

                                                        if (needSSR) {
                                                            _context5.next = 14;
                                                            break;
                                                        }

                                                        mpaConfig.entry[entryName] = ['./entries/' + entryName + '/entry-client.js'];

                                                        _context5.next = 5;
                                                        return _this2.addHtmlPlugin(mpaConfig, entryName, baseUrl);

                                                    case 5:
                                                        skeletonPath = (0, _path.join)(rootDir, 'entries/' + entryName + '/Skeleton.vue');
                                                        skeletonImportPath = '@/entries/' + entryName + '/Skeleton.vue';
                                                        _context5.next = 9;
                                                        return (0, _fsExtra.pathExists)(skeletonPath);

                                                    case 9:
                                                        if (!_context5.sent) {
                                                            _context5.next = 14;
                                                            break;
                                                        }

                                                        _context5.next = 12;
                                                        return _this2.createSkeletonEntry(entryName, skeletonImportPath);

                                                    case 12:
                                                        entryPath = _context5.sent;

                                                        skeletonEntries[entryName] = [entryPath];

                                                    case 14:
                                                    case 'end':
                                                        return _context5.stop();
                                                }
                                            }
                                        }, _callee5, _this2);
                                    }));

                                    return function (_x9) {
                                        return _ref6.apply(this, arguments);
                                    };
                                }()));

                            case 8:

                                if ((0, _keys2.default)(skeletonEntries).length) {
                                    skeletonConfig = this.webpackConfig.server({ cssExtract: true });

                                    skeletonConfig.plugins.pop();
                                    skeletonConfig.entry = skeletonEntries;

                                    mpaConfig.plugins.push(new _vueSkeletonWebpackPlugin2.default({
                                        webpackConfig: skeletonConfig
                                    }));
                                }

                                if (!this.isDev) {
                                    _context6.next = 12;
                                    break;
                                }

                                _context6.next = 12;
                                return (0, _webpack5.enableHotReload)(this.lavasDir, mpaConfig, true);

                            case 12:
                                return _context6.abrupt('return', mpaConfig);

                            case 13:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function createMPAConfig() {
                return _ref5.apply(this, arguments);
            }

            return createMPAConfig;
        }()
    }, {
        key: 'writeConfigFile',
        value: function () {
            var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(config) {
                var configFilePath;
                return _regenerator2.default.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                configFilePath = (0, _path2.distLavasPath)(config.build.path, _constants.CONFIG_FILE);
                                _context7.next = 3;
                                return (0, _fsExtra.outputFile)(configFilePath, JsonUtil.stringify(config));

                            case 3:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function writeConfigFile(_x10) {
                return _ref7.apply(this, arguments);
            }

            return writeConfigFile;
        }()
    }, {
        key: 'writeLavasLink',
        value: function () {
            var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8() {
                var writeFile, lavasLinkTemplate;
                return _regenerator2.default.wrap(function _callee8$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                writeFile = this.isDev ? _webpack5.writeFileInDev : _fsExtra.outputFile;
                                _context8.next = 3;
                                return (0, _fsExtra.readFile)(templatesPath('LavasLink.js.tmpl'), 'utf8');

                            case 3:
                                lavasLinkTemplate = _context8.sent;
                                _context8.next = 6;
                                return writeFile((0, _path.join)(this.lavasDir, 'LavasLink.js'), (0, _lodash2.default)(lavasLinkTemplate)({
                                    entryConfig: JsonUtil.stringify(this.config.entry)
                                }));

                            case 6:
                            case 'end':
                                return _context8.stop();
                        }
                    }
                }, _callee8, this);
            }));

            function writeLavasLink() {
                return _ref8.apply(this, arguments);
            }

            return writeLavasLink;
        }()
    }, {
        key: 'injectEntriesToSW',
        value: function () {
            var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9() {
                var rawTemplate, swTemplateContent, swTemplateFilePath;
                return _regenerator2.default.wrap(function _callee9$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:
                                _context9.next = 2;
                                return (0, _fsExtra.readFile)(templatesPath('service-worker.js.tmpl'));

                            case 2:
                                rawTemplate = _context9.sent;
                                swTemplateContent = (0, _lodash2.default)(rawTemplate, {
                                    evaluate: /{{([\s\S]+?)}}/g,
                                    interpolate: /{{=([\s\S]+?)}}/g,
                                    escape: /{{-([\s\S]+?)}}/g
                                })({
                                    entryConfig: JsonUtil.stringify(this.config.entry)
                                });
                                swTemplateFilePath = templatesPath('service-worker-real.js.tmpl');
                                _context9.next = 7;
                                return (0, _fsExtra.outputFile)(swTemplateFilePath, swTemplateContent);

                            case 7:
                            case 'end':
                                return _context9.stop();
                        }
                    }
                }, _callee9, this);
            }));

            function injectEntriesToSW() {
                return _ref9.apply(this, arguments);
            }

            return injectEntriesToSW;
        }()
    }, {
        key: 'addSkeletonRoutes',
        value: function addSkeletonRoutes(clientConfig) {
            var _this3 = this;

            var _config = this.config,
                rootDir = _config.globals.rootDir,
                entry = _config.entry;

            var entriesWithSkeleton = entry.filter(function () {
                var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10(e) {
                    var name, ssr, skeletonPath;
                    return _regenerator2.default.wrap(function _callee10$(_context10) {
                        while (1) {
                            switch (_context10.prev = _context10.next) {
                                case 0:
                                    name = e.name, ssr = e.ssr;
                                    skeletonPath = (0, _path.join)(rootDir, 'entries/' + name + '/Skeleton.vue');
                                    _context10.t0 = !ssr;

                                    if (!_context10.t0) {
                                        _context10.next = 7;
                                        break;
                                    }

                                    _context10.next = 6;
                                    return (0, _fsExtra.pathExists)(skeletonPath);

                                case 6:
                                    _context10.t0 = _context10.sent;

                                case 7:
                                    return _context10.abrupt('return', _context10.t0);

                                case 8:
                                case 'end':
                                    return _context10.stop();
                            }
                        }
                    }, _callee10, _this3);
                }));

                return function (_x11) {
                    return _ref10.apply(this, arguments);
                };
            }());

            clientConfig.module.rules.push(_vueSkeletonWebpackPlugin2.default.loader({
                resource: entriesWithSkeleton.map(function (e) {
                    return (0, _path.join)(rootDir, '.lavas/' + e.name + '/router');
                }),
                options: {
                    entry: entriesWithSkeleton.map(function (e) {
                        return e.name;
                    }),
                    importTemplate: 'import [nameCap] from \'@/entries/[name]/Skeleton.vue\';',
                    routePathTemplate: '/skeleton-[name]',
                    insertAfter: 'let routes = ['
                }
            }));
        }
    }, {
        key: 'addWatcher',
        value: function addWatcher(paths, events, callback) {
            if (!Array.isArray(events)) {
                events = [events];
            }
            var watcher = _chokidar2.default.watch(paths, { ignoreInitial: true });
            events.forEach(function (event) {
                watcher.on(event, callback);
            });
            this.watchers.push(watcher);
        }
    }, {
        key: 'reloadClient',
        value: function reloadClient() {
            if (this.oldHotMiddleware) {
                this.oldHotMiddleware.publish({
                    action: 'reload'
                });
            }
        }
    }, {
        key: 'rebuild',
        value: function () {
            var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11() {
                var newConfig;
                return _regenerator2.default.wrap(function _callee11$(_context11) {
                    while (1) {
                        switch (_context11.prev = _context11.next) {
                            case 0:
                                console.log('[Lavas] config changed, start rebuilding...');
                                _context11.next = 3;
                                return this.core.configReader.read();

                            case 3:
                                newConfig = _context11.sent;

                                this.core.config = newConfig;
                                this.init(newConfig);
                                this.core.internalMiddlewares = [];
                                this.core.emit('rebuild');

                            case 8:
                            case 'end':
                                return _context11.stop();
                        }
                    }
                }, _callee11, this);
            }));

            function rebuild() {
                return _ref11.apply(this, arguments);
            }

            return rebuild;
        }()
    }, {
        key: 'buildDev',
        value: function () {
            var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee17() {
                var _this4 = this;

                var mpaConfig, clientConfig, serverConfig, hotMiddleware, clientCompiler, serverCompiler, clientMFS, noop, serverMFS, mpaEntries, rewrites, pagesDir, configDir;
                return _regenerator2.default.wrap(function _callee17$(_context17) {
                    while (1) {
                        switch (_context17.prev = _context17.next) {
                            case 0:
                                this.isDev = true;
                                mpaConfig = void 0;
                                clientConfig = void 0;
                                serverConfig = void 0;
                                hotMiddleware = void 0;
                                clientCompiler = void 0;
                                serverCompiler = void 0;
                                clientMFS = void 0;

                                noop = function noop() {};

                                _context17.next = 11;
                                return this.routeManager.buildRoutes();

                            case 11:
                                _context17.next = 13;
                                return this.writeLavasLink();

                            case 13:
                                if (!this.ssrExists) {
                                    _context17.next = 26;
                                    break;
                                }

                                console.log('[Lavas] SSR build starting...');
                                clientConfig = this.webpackConfig.client();
                                serverConfig = this.webpackConfig.server();
                                serverMFS = new _memoryFs2.default();

                                this.renderer.addWatcher = this.addWatcher.bind(this);
                                this.renderer.reloadClient = this.reloadClient.bind(this);
                                _context17.next = 22;
                                return this.renderer.build(clientConfig, serverConfig);

                            case 22:
                                this.renderer.serverMFS = serverMFS;

                                serverCompiler = (0, _webpack4.default)(serverConfig);
                                serverCompiler.outputFileSystem = serverMFS;

                                this.serverWatching = serverCompiler.watch({}, function () {
                                    var _ref13 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12(err, stats) {
                                        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, error;

                                        return _regenerator2.default.wrap(function _callee12$(_context12) {
                                            while (1) {
                                                switch (_context12.prev = _context12.next) {
                                                    case 0:
                                                        if (!err) {
                                                            _context12.next = 2;
                                                            break;
                                                        }

                                                        throw err;

                                                    case 2:
                                                        stats = stats.toJson();

                                                        if (!stats.errors.length) {
                                                            _context12.next = 24;
                                                            break;
                                                        }

                                                        _iteratorNormalCompletion = true;
                                                        _didIteratorError = false;
                                                        _iteratorError = undefined;
                                                        _context12.prev = 7;

                                                        for (_iterator = (0, _getIterator3.default)(stats.errors); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                                                            error = _step.value;

                                                            console.error(error);
                                                        }
                                                        _context12.next = 15;
                                                        break;

                                                    case 11:
                                                        _context12.prev = 11;
                                                        _context12.t0 = _context12['catch'](7);
                                                        _didIteratorError = true;
                                                        _iteratorError = _context12.t0;

                                                    case 15:
                                                        _context12.prev = 15;
                                                        _context12.prev = 16;

                                                        if (!_iteratorNormalCompletion && _iterator.return) {
                                                            _iterator.return();
                                                        }

                                                    case 18:
                                                        _context12.prev = 18;

                                                        if (!_didIteratorError) {
                                                            _context12.next = 21;
                                                            break;
                                                        }

                                                        throw _iteratorError;

                                                    case 21:
                                                        return _context12.finish(18);

                                                    case 22:
                                                        return _context12.finish(15);

                                                    case 23:
                                                        return _context12.abrupt('return');

                                                    case 24:
                                                        _context12.next = 26;
                                                        return _this4.renderer.refreshFiles();

                                                    case 26:
                                                    case 'end':
                                                        return _context12.stop();
                                                }
                                            }
                                        }, _callee12, _this4, [[7, 11, 15, 23], [16,, 18, 22]]);
                                    }));

                                    return function (_x12, _x13) {
                                        return _ref13.apply(this, arguments);
                                    };
                                }());

                            case 26:
                                if (!this.mpaExists) {
                                    _context17.next = 32;
                                    break;
                                }

                                console.log('[Lavas] MPA build starting...');
                                _context17.next = 30;
                                return this.createMPAConfig();

                            case 30:
                                mpaConfig = _context17.sent;

                                this.addSkeletonRoutes(mpaConfig);

                            case 32:
                                clientCompiler = (0, _webpack4.default)([clientConfig, mpaConfig].filter(function (config) {
                                    return config;
                                }));
                                clientCompiler.cache = this.sharedCache;

                                this.devMiddleware = (0, _webpackDevMiddleware2.default)(clientCompiler, {
                                    publicPath: this.config.build.publicPath,
                                    noInfo: true
                                });

                                clientMFS = this.devMiddleware.fileSystem;
                                clientCompiler.outputFileSystem = clientMFS;
                                if (this.ssrExists) {
                                    this.renderer.clientMFS = clientMFS;
                                }

                                hotMiddleware = (0, _webpackHotMiddleware2.default)(clientCompiler, {
                                    heartbeat: 5000,
                                    log: noop
                                });

                                clientCompiler.plugin('compilation', function (compilation) {
                                    compilation.plugin('html-webpack-plugin-after-emit', function (data, cb) {
                                        hotMiddleware.publish({
                                            action: 'reload'
                                        });
                                        cb();
                                    });
                                });

                                if (!this.ssrExists) {
                                    mpaEntries = this.config.entry.filter(function (e) {
                                        return !e.ssr;
                                    });
                                    rewrites = mpaEntries.map(function (entry) {
                                        var name = entry.name,
                                            routes = entry.routes,
                                            base = entry.base;

                                        return {
                                            from: (0, _router.routes2Reg)(routes),
                                            to: _path.posix.join(base, '/' + name + '.html')
                                        };
                                    });

                                    this.core.internalMiddlewares.push((0, _connectHistoryApiFallback2.default)({
                                        htmlAcceptHeaders: ['text/html'],
                                        disableDotRule: false,
                                        rewrites: rewrites
                                    }));
                                }

                                this.core.internalMiddlewares.push(this.devMiddleware);
                                this.core.internalMiddlewares.push(hotMiddleware);

                                _context17.next = 45;
                                return new _promise2.default(function (resolve) {
                                    _this4.devMiddleware.waitUntilValid((0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee13() {
                                        return _regenerator2.default.wrap(function _callee13$(_context13) {
                                            while (1) {
                                                switch (_context13.prev = _context13.next) {
                                                    case 0:
                                                        if (_this4.mpaExists) {
                                                            console.log('[Lavas] MPA build completed.');
                                                        }

                                                        if (!_this4.ssrExists) {
                                                            _context13.next = 5;
                                                            break;
                                                        }

                                                        _context13.next = 4;
                                                        return _this4.renderer.refreshFiles();

                                                    case 4:
                                                        console.log('[Lavas] SSR build completed.');

                                                    case 5:
                                                        if (_this4.oldHotMiddleware) {
                                                            _this4.oldHotMiddleware.publish({
                                                                action: 'reload'
                                                            });
                                                        }

                                                        _this4.oldHotMiddleware = hotMiddleware;
                                                        resolve();

                                                    case 8:
                                                    case 'end':
                                                        return _context13.stop();
                                                }
                                            }
                                        }, _callee13, _this4);
                                    })));
                                });

                            case 45:
                                pagesDir = (0, _path.join)(this.config.globals.rootDir, 'pages');

                                this.addWatcher(pagesDir, ['add', 'unlink'], (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee14() {
                                    return _regenerator2.default.wrap(function _callee14$(_context14) {
                                        while (1) {
                                            switch (_context14.prev = _context14.next) {
                                                case 0:
                                                    _context14.next = 2;
                                                    return _this4.routeManager.buildRoutes();

                                                case 2:
                                                case 'end':
                                                    return _context14.stop();
                                            }
                                        }
                                    }, _callee14, _this4);
                                })));

                                if (this.config.build.watch) {
                                    this.addWatcher(this.config.build.watch, 'change', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee15() {
                                        return _regenerator2.default.wrap(function _callee15$(_context15) {
                                            while (1) {
                                                switch (_context15.prev = _context15.next) {
                                                    case 0:
                                                        _context15.next = 2;
                                                        return _this4.rebuild();

                                                    case 2:
                                                    case 'end':
                                                        return _context15.stop();
                                                }
                                            }
                                        }, _callee15, _this4);
                                    })));
                                }

                                configDir = (0, _path.join)(this.config.globals.rootDir, 'config');

                                this.addWatcher(configDir, 'change', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee16() {
                                    return _regenerator2.default.wrap(function _callee16$(_context16) {
                                        while (1) {
                                            switch (_context16.prev = _context16.next) {
                                                case 0:
                                                    _context16.next = 2;
                                                    return _this4.rebuild();

                                                case 2:
                                                case 'end':
                                                    return _context16.stop();
                                            }
                                        }
                                    }, _callee16, _this4);
                                })));

                            case 50:
                            case 'end':
                                return _context17.stop();
                        }
                    }
                }, _callee17, this);
            }));

            function buildDev() {
                return _ref12.apply(this, arguments);
            }

            return buildDev;
        }()
    }, {
        key: 'buildProd',
        value: function () {
            var _ref18 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee19() {
                var _this5 = this;

                var _config2, build, globals, clientConfig, serverConfig;

                return _regenerator2.default.wrap(function _callee19$(_context19) {
                    while (1) {
                        switch (_context19.prev = _context19.next) {
                            case 0:
                                this.isProd = true;
                                _config2 = this.config, build = _config2.build, globals = _config2.globals;
                                _context19.next = 4;
                                return (0, _fsExtra.emptyDir)(build.path);

                            case 4:
                                _context19.next = 6;
                                return this.injectEntriesToSW();

                            case 6:
                                _context19.next = 8;
                                return this.routeManager.buildRoutes();

                            case 8:
                                _context19.next = 10;
                                return this.writeLavasLink();

                            case 10:
                                if (!this.ssrExists) {
                                    _context19.next = 22;
                                    break;
                                }

                                console.log('[Lavas] SSR build starting...');
                                clientConfig = this.webpackConfig.client();
                                serverConfig = this.webpackConfig.server();
                                _context19.next = 16;
                                return this.renderer.build(clientConfig, serverConfig);

                            case 16:
                                _context19.next = 18;
                                return this.writeConfigFile(this.config);

                            case 18:
                                if (!build.ssrCopy) {
                                    _context19.next = 21;
                                    break;
                                }

                                _context19.next = 21;
                                return _promise2.default.all(build.ssrCopy.map(function () {
                                    var _ref19 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee18(_ref20) {
                                        var src = _ref20.src,
                                            _ref20$dest = _ref20.dest,
                                            dest = _ref20$dest === undefined ? src : _ref20$dest,
                                            _ref20$options = _ref20.options,
                                            options = _ref20$options === undefined ? {} : _ref20$options;
                                        return _regenerator2.default.wrap(function _callee18$(_context18) {
                                            while (1) {
                                                switch (_context18.prev = _context18.next) {
                                                    case 0:
                                                        _context18.next = 2;
                                                        return (0, _fsExtra.copy)((0, _path.join)(globals.rootDir, src), (0, _path.join)(build.path, dest), options);

                                                    case 2:
                                                    case 'end':
                                                        return _context18.stop();
                                                }
                                            }
                                        }, _callee18, _this5);
                                    }));

                                    return function (_x14) {
                                        return _ref19.apply(this, arguments);
                                    };
                                }()));

                            case 21:
                                console.log('[Lavas] SSR build completed.');

                            case 22:
                                if (!this.mpaExists) {
                                    _context19.next = 31;
                                    break;
                                }

                                console.log('[Lavas] MPA build starting...');
                                _context19.t0 = _webpack5.webpackCompile;
                                _context19.next = 27;
                                return this.createMPAConfig();

                            case 27:
                                _context19.t1 = _context19.sent;
                                _context19.next = 30;
                                return (0, _context19.t0)(_context19.t1);

                            case 30:
                                console.log('[Lavas] MPA build completed.');

                            case 31:
                            case 'end':
                                return _context19.stop();
                        }
                    }
                }, _callee19, this);
            }));

            function buildProd() {
                return _ref18.apply(this, arguments);
            }

            return buildProd;
        }()
    }, {
        key: 'close',
        value: function () {
            var _ref21 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee20() {
                var _this6 = this;

                return _regenerator2.default.wrap(function _callee20$(_context20) {
                    while (1) {
                        switch (_context20.prev = _context20.next) {
                            case 0:
                                if (this.watchers && this.watchers.length) {
                                    this.watchers.forEach(function (watcher) {
                                        watcher.close();
                                    });
                                    this.watchers = [];
                                }

                                if (!this.devMiddleware) {
                                    _context20.next = 4;
                                    break;
                                }

                                _context20.next = 4;
                                return new _promise2.default(function (resolve) {
                                    _this6.devMiddleware.close(function () {
                                        return resolve();
                                    });
                                });

                            case 4:
                                if (!this.serverWatching) {
                                    _context20.next = 8;
                                    break;
                                }

                                _context20.next = 7;
                                return new _promise2.default(function (resolve) {
                                    _this6.serverWatching.close(function () {
                                        return resolve();
                                    });
                                });

                            case 7:
                                this.serverWatching = null;

                            case 8:
                            case 'end':
                                return _context20.stop();
                        }
                    }
                }, _callee20, this);
            }));

            function close() {
                return _ref21.apply(this, arguments);
            }

            return close;
        }()
    }]);
    return Builder;
}();

exports.default = Builder;
module.exports = exports['default'];