'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _renderer = require('./renderer');

var _renderer2 = _interopRequireDefault(_renderer);

var _configReader = require('./config-reader');

var _configReader2 = _interopRequireDefault(_configReader);

var _builder = require('./builder');

var _builder2 = _interopRequireDefault(_builder);

var _privateFile = require('./middlewares/privateFile');

var _privateFile2 = _interopRequireDefault(_privateFile);

var _ssr = require('./middlewares/ssr');

var _ssr2 = _interopRequireDefault(_ssr);

var _koaError = require('./middlewares/koaError');

var _koaError2 = _interopRequireDefault(_koaError);

var _expressError = require('./middlewares/expressError');

var _expressError2 = _interopRequireDefault(_expressError);

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

var _composeMiddleware = require('compose-middleware');

var _koaCompose = require('koa-compose');

var _koaCompose2 = _interopRequireDefault(_koaCompose);

var _koaConnect = require('koa-connect');

var _koaConnect2 = _interopRequireDefault(_koaConnect);

var _koaMount = require('koa-mount');

var _koaMount2 = _interopRequireDefault(_koaMount);

var _koaStatic = require('koa-static');

var _koaStatic2 = _interopRequireDefault(_koaStatic);

var _koaSend = require('koa-send');

var _koaSend2 = _interopRequireDefault(_koaSend);

var _serveStatic = require('serve-static');

var _serveStatic2 = _interopRequireDefault(_serveStatic);

var _serveFavicon = require('serve-favicon');

var _serveFavicon2 = _interopRequireDefault(_serveFavicon);

var _compression = require('compression');

var _compression2 = _interopRequireDefault(_compression);

var _path = require('path');

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LavasCore = function (_EventEmitter) {
    (0, _inherits3.default)(LavasCore, _EventEmitter);

    function LavasCore() {
        var cwd = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();
        (0, _classCallCheck3.default)(this, LavasCore);

        var _this = (0, _possibleConstructorReturn3.default)(this, (LavasCore.__proto__ || (0, _getPrototypeOf2.default)(LavasCore)).call(this));

        _this.cwd = cwd;
        return _this;
    }

    (0, _createClass3.default)(LavasCore, [{
        key: 'init',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(env, isInBuild) {
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                this.env = env;
                                this.isProd = this.env === 'production';
                                this.configReader = new _configReader2.default(this.cwd, this.env);

                                if (!isInBuild) {
                                    _context.next = 9;
                                    break;
                                }

                                _context.next = 6;
                                return this.configReader.read();

                            case 6:
                                this.config = _context.sent;
                                _context.next = 12;
                                break;

                            case 9:
                                _context.next = 11;
                                return this.configReader.readConfigFile();

                            case 11:
                                this.config = _context.sent;

                            case 12:

                                this.internalMiddlewares = [];
                                this.renderer = new _renderer2.default(this);
                                this.builder = new _builder2.default(this);

                            case 15:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function init(_x2, _x3) {
                return _ref.apply(this, arguments);
            }

            return init;
        }()
    }, {
        key: 'build',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
                var spinner;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                spinner = (0, _ora2.default)();


                                spinner.start();

                                if (!this.isProd) {
                                    _context2.next = 7;
                                    break;
                                }

                                _context2.next = 5;
                                return this.builder.buildProd();

                            case 5:
                                _context2.next = 10;
                                break;

                            case 7:
                                this.setupInternalMiddlewares();
                                _context2.next = 10;
                                return this.builder.buildDev();

                            case 10:
                                spinner.succeed('[Lavas] ' + this.env + ' build completed.');

                            case 11:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function build() {
                return _ref2.apply(this, arguments);
            }

            return build;
        }()
    }, {
        key: 'setupInternalMiddlewares',
        value: function setupInternalMiddlewares() {
            this.internalMiddlewares.push((0, _compression2.default)());

            var faviconPath = (0, _path.join)(this.cwd, 'static/img/icons', 'favicon.ico');
            this.internalMiddlewares.push((0, _serveFavicon2.default)(faviconPath));
        }
    }, {
        key: 'runAfterBuild',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                this.setupInternalMiddlewares();
                                this.renderer = new _renderer2.default(this);
                                _context3.next = 4;
                                return this.renderer.createWithBundle();

                            case 4:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function runAfterBuild() {
                return _ref3.apply(this, arguments);
            }

            return runAfterBuild;
        }()
    }, {
        key: 'koaMiddleware',
        value: function koaMiddleware() {
            var _this2 = this;

            var _config = this.config,
                entry = _config.entry,
                publicPath = _config.build.publicPath,
                serviceWorker = _config.serviceWorker;

            var ssrExists = entry.some(function (e) {
                return e.ssr;
            });

            var middlewares = [(0, _koaError2.default)(this), function () {
                var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(ctx, next) {
                    return _regenerator2.default.wrap(function _callee4$(_context4) {
                        while (1) {
                            switch (_context4.prev = _context4.next) {
                                case 0:
                                    ctx.status = 200;
                                    _context4.next = 3;
                                    return next();

                                case 3:
                                case 'end':
                                    return _context4.stop();
                            }
                        }
                    }, _callee4, _this2);
                }));

                return function (_x4, _x5) {
                    return _ref4.apply(this, arguments);
                };
            }(), (0, _koaConnect2.default)((0, _privateFile2.default)(this))].concat((0, _toConsumableArray3.default)(this.internalMiddlewares.map(_koaConnect2.default)));

            if (this.isProd) {
                middlewares.push((0, _koaMount2.default)(_path.posix.join(publicPath, _constants.ASSETS_DIRNAME_IN_DIST), (0, _koaStatic2.default)((0, _path.join)(this.cwd, _constants.ASSETS_DIRNAME_IN_DIST))));

                var swFiles = [(0, _path.basename)(serviceWorker.swDest), 'sw-register.js'].map(function (f) {
                    return _path.posix.join(publicPath, f);
                });
                middlewares.push(function () {
                    var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(ctx, next) {
                        var done;
                        return _regenerator2.default.wrap(function _callee5$(_context5) {
                            while (1) {
                                switch (_context5.prev = _context5.next) {
                                    case 0:
                                        done = false;

                                        if (!swFiles.includes(ctx.path)) {
                                            _context5.next = 6;
                                            break;
                                        }

                                        ctx.set('Cache-Control', 'private, no-cache, no-store');
                                        _context5.next = 5;
                                        return (0, _koaSend2.default)(ctx, ctx.path, {
                                            root: _this2.cwd
                                        });

                                    case 5:
                                        done = _context5.sent;

                                    case 6:
                                        if (done) {
                                            _context5.next = 9;
                                            break;
                                        }

                                        _context5.next = 9;
                                        return next();

                                    case 9:
                                    case 'end':
                                        return _context5.stop();
                                }
                            }
                        }, _callee5, _this2);
                    }));

                    return function (_x6, _x7) {
                        return _ref5.apply(this, arguments);
                    };
                }());
            }
            if (ssrExists) {
                middlewares.push((0, _koaConnect2.default)((0, _ssr2.default)(this)));
            }

            return (0, _koaCompose2.default)(middlewares);
        }
    }, {
        key: 'expressMiddleware',
        value: function expressMiddleware() {
            var _config2 = this.config,
                entry = _config2.entry,
                publicPath = _config2.build.publicPath,
                serviceWorker = _config2.serviceWorker;

            var ssrExists = entry.some(function (e) {
                return e.ssr;
            });

            if (this.isProd) {
                this.internalMiddlewares.push((0, _serveStatic2.default)((0, _path.join)(this.cwd, _constants.ASSETS_DIRNAME_IN_DIST)));

                var swFiles = [(0, _path.basename)(serviceWorker.swDest), 'sw-register.js'].map(function (f) {
                    return _path.posix.join(publicPath, f);
                });
            }

            return (0, _composeMiddleware.compose)([(0, _privateFile2.default)(this)].concat((0, _toConsumableArray3.default)(this.internalMiddlewares), [ssrExists ? (0, _ssr2.default)(this) : function () {}, (0, _expressError2.default)(this)]));
        }
    }, {
        key: 'close',
        value: function () {
            var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
                return _regenerator2.default.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                _context6.next = 2;
                                return this.builder.close();

                            case 2:
                                console.log('[Lavas] lavas closed.');

                            case 3:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function close() {
                return _ref6.apply(this, arguments);
            }

            return close;
        }()
    }, {
        key: 'ignore',
        value: function ignore(req) {
            req.lavasIgnoreFlag = true;
        }
    }]);
    return LavasCore;
}(_events2.default);

exports.default = LavasCore;
module.exports = exports['default'];