'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getStaticHtml = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(fileSystem, cwd, entryName, enableCache) {
        var entry;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (enableCache) {
                            _context.next = 2;
                            break;
                        }

                        return _context.abrupt('return', fileSystem.readFileSync((0, _path.join)(cwd, 'dist/' + entryName + '.html'), 'utf8'));

                    case 2:
                        entry = STATIC_HTML_CACHE.get(entryName);

                        if (entry) {
                            _context.next = 12;
                            break;
                        }

                        if (!fileSystem) {
                            _context.next = 8;
                            break;
                        }

                        entry = fileSystem.readFileSync((0, _path.join)(cwd, 'dist/' + entryName + '.html'), 'utf8');
                        _context.next = 11;
                        break;

                    case 8:
                        _context.next = 10;
                        return (0, _fsExtra.readFile)((0, _path.join)(cwd, entryName + '.html'), 'utf8');

                    case 10:
                        entry = _context.sent;

                    case 11:
                        STATIC_HTML_CACHE.set(entryName, entry);

                    case 12:
                        return _context.abrupt('return', entry);

                    case 13:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function getStaticHtml(_x, _x2, _x3, _x4) {
        return _ref.apply(this, arguments);
    };
}();

exports.default = function (core) {
    var cwd = core.cwd,
        config = core.config,
        renderer = core.renderer,
        builder = core.builder,
        isProd = core.isProd;

    return function () {
        var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(req, res, next) {
            var url, matchedEntry, needSSR, entryName, devFs, matchedRenderer, errorHandler, ctx;
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            if (!req.lavasIgnoreFlag) {
                                _context2.next = 2;
                                break;
                            }

                            return _context2.abrupt('return', next());

                        case 2:
                            url = req.url;
                            matchedEntry = config.entry.find(function (entryConfig) {
                                return (0, _router.matchUrl)(entryConfig.routes, url);
                            });

                            if (matchedEntry) {
                                _context2.next = 6;
                                break;
                            }

                            return _context2.abrupt('return', next(new Error(url + ' not found')));

                        case 6:
                            needSSR = matchedEntry.ssr, entryName = matchedEntry.name;

                            if (needSSR) {
                                _context2.next = 17;
                                break;
                            }

                            console.log('[Lavas] route middleware: static ' + url);
                            devFs = builder && builder.devMiddleware && builder.devMiddleware.fileSystem;
                            _context2.t0 = res;
                            _context2.next = 13;
                            return getStaticHtml(devFs, cwd, entryName, isProd);

                        case 13:
                            _context2.t1 = _context2.sent;

                            _context2.t0.end.call(_context2.t0, _context2.t1);

                            _context2.next = 24;
                            break;

                        case 17:
                            console.log('[Lavas] route middleware: ssr ' + url);
                            _context2.next = 20;
                            return renderer.getRenderer(entryName);

                        case 20:
                            matchedRenderer = _context2.sent;

                            errorHandler = function errorHandler(err) {
                                return next(err);
                            };

                            ctx = {
                                title: 'Lavas',
                                url: url,
                                entryName: entryName,
                                config: config,
                                req: req,
                                res: res,
                                error: errorHandler
                            };

                            matchedRenderer.renderToString(ctx, function (err, html) {
                                if (err) {
                                    return next(err);
                                }
                                res.end(html);
                            });

                        case 24:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        return function (_x5, _x6, _x7) {
            return _ref2.apply(this, arguments);
        };
    }();
};

var _fsExtra = require('fs-extra');

var _path = require('path');

var _lruCache = require('lru-cache');

var _lruCache2 = _interopRequireDefault(_lruCache);

var _router = require('../utils/router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var STATIC_HTML_CACHE = (0, _lruCache2.default)({
    max: 1000,
    maxAge: 1000 * 60 * 15
});

module.exports = exports['default'];